def hw_u_bolt(x0,y0,z0,nb0,r0,l0)

    model = Sketchup.active_model
    entities = model.entities
    group=entities.add_group
    entities=group.entities
    group.name="U_BOLT"
    
    model.start_operation "u bolt"
 
    x=x0
    y=y0
    z=z0
    
    nb=nb0
    r=r0
    l=l0

    p1 = Geom::Point3d.new(x,y,z)
    p2 = Geom::Point3d.new(x+l0,y,z)
    p3 = Geom::Point3d.new(x+l0,y+nb,z)
    p4 = Geom::Point3d.new(x,y+nb,z)
    
    @@theEdges= []  
    @@edges=[]
    
    @@theEdges[0] = entities.add_line(p1,p2)
    
    s=10
    vecz = Geom::Vector3d.new(0, 0, 1)
    vecx = Geom::Vector3d.new(1, 0, 0)
    @@edges =entities.add_arc([x+l, y+nb/2, z], vecx, vecz, nb/2, -90.degrees, 90.degrees, s)
    
    for i in 0..s-1 
      @@theEdges[i+1] = @@edges[i]
    end
    
    @@theEdges[s+1] = entities.add_line(p3,p4)
    
    vector=X_AXIS
    
    circleI = entities.add_circle p1, vector, r
    base = entities.add_face circleI
    base.reverse!.followme @@theEdges

    model.commit_operation

end #def hw_u_bolt

def hw_u_bolt_test

    x=0
    y=0
    z=0
    
    nb=100
    r=12/2
    l=500
    
    hw_u_bolt(x,y,z,nb,r,l)

end #def hw_u_bolt_test


#UI.menu("Plugins").add_separator
UI.menu("Plugins").add_item("Test u bolt") { hw_u_bolt_test }

